package com.persagy.iottransfer.communication.mina.codec;

import org.apache.mina.core.session.IoSession;
import org.apache.mina.filter.codec.ProtocolCodecFactory;
import org.apache.mina.filter.codec.ProtocolDecoder;
import org.apache.mina.filter.codec.ProtocolEncoder;

import java.util.List;

public class MinaCodecFactory implements ProtocolCodecFactory {
    private final ProtocolEncoder encoder;
    private final ProtocolDecoder decoder;

    public MinaCodecFactory(String ip, int port, String encoding, String aes_password, boolean compress) {
        encoder = new MinaPacketEncoder(ip, port, encoding, aes_password, compress);
        decoder = new MinaPacketDecoder(ip, port, encoding, aes_password, compress);
    }

    public MinaCodecFactory(String ip, int port, String encoding, String aes_password, boolean compress, byte prefix,
                            byte suffix) {
        encoder = new MinaPacketEncoder(ip, port, encoding, aes_password, compress, prefix, suffix);
        decoder = new MinaPacketDecoder(ip, port, encoding, aes_password, compress, prefix, suffix);
    }

    public MinaCodecFactory(String ip, int port, String encoding, String aes_password, boolean compress,
                            byte[] prefixBytes, byte[] suffixBytes) {
        encoder = new MinaPacketEncoder(ip, port, encoding, aes_password, compress, prefixBytes, suffixBytes);
        decoder = new MinaPacketDecoder(ip, port, encoding, aes_password, compress, prefixBytes, suffixBytes);
    }

    public static void add_forbit_byte(byte b, List<Byte> byteList) {
        boolean exist = false;
        for (Byte bb : byteList) {
            if (bb == b) {
                exist = true;
                break;
            }
        }
        if (!exist) {
            byteList.add(b);
        }
    }

    public static void add_forbit_bytes(byte[] bytes, List<Byte> byteList) {
        for (byte b : bytes) {
            boolean exist = false;
            for (Byte bb : byteList) {
                if (bb == b) {
                    exist = true;
                    break;
                }
            }
            if (!exist) {
                byteList.add(b);
            }
        }
    }

    @Override
    public ProtocolEncoder getEncoder(IoSession ioSession) throws Exception {
        return encoder;
    }

    @Override
    public ProtocolDecoder getDecoder(IoSession ioSession) throws Exception {
        return decoder;
    }
}
