package com.persagy.iottransfer.communication.util;

import java.util.List;

public class HexToByte {
    public synchronized static byte[] hexToByte(String hex) {
        return hexToByte(hex, false);
    }

    public synchronized static byte[] hexToByte(String hex, boolean hasspace) {
        byte[] result;

        if (hasspace) {
            result = new byte[(hex.length() + 1) / 3];
            for (int i = 0; i < result.length; i++) {
                result[i] = Integer.decode("0x" + hex.substring(i * 3, i * 3 + 2)).byteValue();
            }
        } else {
            result = new byte[hex.length() / 2];
            for (int i = 0; i < result.length; i++) {
                result[i] = Integer.decode("0x" + hex.substring(i * 2, i * 2 + 2)).byteValue();
            }
        }
        return result;
    }

    public synchronized static String byteToHex(byte[] bytes) {
        return byteToHex(bytes, false);
    }

    public synchronized static String byteToHex(byte[] bytes, boolean hasspace) {
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < bytes.length; i++) {
            if (hasspace && i > 0) {
                sb.append(" ");
            }
            int temp = (bytes[i] + 256) % 256;
            sb.append("" + getHexChar(temp / 16) + getHexChar(temp % 16));
        }
        return sb.toString();
    }

    public synchronized static String byteToHex(List<Byte> bytes) {
        return byteToHex(bytes, false);
    }

    public synchronized static String byteToHex(List<Byte> bytes, boolean hasspace) {
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < bytes.size(); i++) {
            if (hasspace && i > 0) {
                sb.append(" ");
            }
            int temp = (bytes.get(i) + 256) % 256;
            sb.append("" + getHexChar(temp / 16) + getHexChar(temp % 16));
        }
        return sb.toString();
    }

    public synchronized static String byteToHex(List<Byte> bytes, int length) {
        return byteToHex(bytes, false);
    }

    public synchronized static String byteToHex(List<Byte> bytes, int length, boolean hasspace) {
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < length; i++) {
            if (hasspace && i > 0) {
                sb.append(" ");
            }
            int temp = (bytes.get(i) + 256) % 256;
            sb.append("" + getHexChar(temp / 16) + getHexChar(temp % 16));
        }
        return sb.toString();
    }

    public synchronized static String byteToHex(byte[] bytes, int length) {
        return byteToHex(bytes, false);
    }

    public synchronized static String byteToHex(byte[] bytes, int length, boolean hasspace) {
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < length; i++) {
            if (hasspace && i > 0) {
                sb.append(" ");
            }
            int temp = (bytes[i] + 256) % 256;
            sb.append("" + getHexChar(temp / 16) + getHexChar(temp % 16));
        }
        return sb.toString();
    }

    private static String getHexChar(int number) {
        String result;
        if (number < 10) {
            result = "" + number;
        } else {
            result = "" + (char) (number - 10 + 'A');
        }
        return result;
    }

    public synchronized static byte[] setVerify(byte[] bytes) {
        int number = 0;
        for (int i = 2; i < bytes.length - 2; i++) {
            number += (bytes[i] + 256) % 256;
        }
        bytes[bytes.length - 2] = (byte) (number % 256);
        bytes[bytes.length - 1] = (byte) (number / 256);
        return bytes;
    }
}
