package com.persagy.iottransfer.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.ArrayList;

/**
 * @description:
 * @author:lgy
 * @data:2021/8/26 15:22
 */
@Component
@ConfigurationProperties(prefix = "iot")
@Data
public class IotProperties {

    public ArrayList<Client> clients;
    public ArrayList<Project> projects;

    @Data
    public static class Project {
        private String id;
        private String PjId;
        private String name;
        private String groupCode;
    }

    @Data
    public static class Client {
        private String protocol;
        private String target_ip;
        private Integer target_port;
        private Integer max_size;
        private Integer sleepcount;

        private String separate_begin;
        private String separate_end;
        private Boolean compress;
        private Boolean transparent;
        private Boolean usecurrentdate;
        private Boolean server_is_iot_collect;
        private Boolean server_is_iot_control;
        private String buildingheart_sign;
    }

}
