package com.persagy.iottransfer.init;

import cn.hutool.core.thread.ThreadUtil;
import com.persagy.iottransfer.client.IotClient;
import com.persagy.iottransfer.client.IotClientReceiveMessageThread;
import com.persagy.iottransfer.config.ProjectClent;
import com.persagy.iottransfer.kafka.KafkaProducer;
import com.persagy.iottransfer.server.IotServer;
import com.persagy.iottransfer.server.IotServerReceiveMessageThread;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

@WebListener
@Slf4j
public class DaemonThread implements ServletContextListener {

    @Autowired
    KafkaProducer kafkaProducer;

    @Autowired
    IotServer iotServer;
    @Autowired
    IotClient iotClient;
    @Autowired
    ProjectClent projectClent;

    @Override
    public void contextInitialized(ServletContextEvent sce) {
        iotServer.init();
        iotClient.init();
        //异步消费消息
        ThreadUtil.execAsync(new IotServerReceiveMessageThread(kafkaProducer, projectClent), true);
        ThreadUtil.execAsync(new IotClientReceiveMessageThread(kafkaProducer), true);
        log.info("----------contextInitialize end--------------");
    }
}